﻿<!DOCTYPE html>
<HTML>
<!--

FastPACS
2006-2013 by Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA


On-Line Support
Contents copyright Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA

-->
<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Globalization" %>
<%@ Import Namespace="DIOWave" %>
<%@ Import Namespace="System.IO" %>
<script src="classes.cs" runat="server" />
<script src="viewer-common.cs" runat="server" />
<script src="viewer-custom.cs" runat="server" />
<script src="viewer-spatial.cs" runat="server" />
<%
//========================================================================================
	setup(Request);
	Writer = Response.Output;

	// Do not store viewer preferences
	//QueryStringValue QSV = new QueryStringValue(Request, m_browser, (StringDictionary)Session["viewerpref"]);
	QueryStringValue QSV = new QueryStringValue(Request, m_browser, new StringDictionary());
	if (QSV.bad) {
		Response.Clear();
		Server.Transfer("/DIOWave/blank1.htm");
	}
	XmlDocument config_dom = (XmlDocument)Application.Get("DIOWaveConf");
	DicomStudy DOM = loadDOM(QSV, config_dom);
	if (DOM==null)
	{
		Response.Clear();
		Server.Transfer("/DIOWave/blank1.htm");
		return;
	}

	ImageSpaceObject ImageSpace = new ImageSpaceObject();
	ArrayList ImageList = new ArrayList();
	foreach (SOPInstanceObject file in DOM.fl)
		ImageList.Add(new ImageObject(file, ImageSpace));
	ImageList.Sort(new ImageObjectComparer());
	ImageSpace.calc_center();

	UInt32 NumImages = (UInt32)DOM.fl.Count;
	LayoutTableObject LayoutTable = new LayoutTableObject(DOM, QSV, NumImages);
	VOITableObject VOITable = new VOITableObject(ImageSpace, DOM, QSV, VOIPresets(DOM));
	SliderPanelObject SliderPanel = new SliderPanelObject(QSV, NumImages, LayoutTable);

//========================================================================================
%>
<HEAD>
<TITLE>Series Viewer</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html;" charset="utf-8">
<link rel="stylesheet" type="text/css" href="media/css/jquery.jscrollpane.css">
    <link rel="stylesheet" type="text/css" href="media/css/reset.css">
    <link rel="stylesheet" type="text/css" href="media/css/chosen.css">
    <link rel="stylesheet" type="text/css" href="media/css/base.css">
    <script type="text/javascript" src="media/js/jquery-1.7.1.min.js"></script>
    <script type="text/javascript" src="media/js/jquery.mousewheel.js"></script>
    <script type="text/javascript" src="media/js/jquery.jscrollpane.js"></script>
    <script type="text/javascript" src="media/js/chosen.jquery.js"></script>
    <script type="text/javascript" src="media/js/jquery-ui.js"></script>
    <!--[if IE 9]> <![endif]-->
    <script type="text/javascript" id="sourcecode">
        $(function()
        {
            $(".chzn-select").css("display","");
            if (!($.browser.msie && parseInt($.browser.version, 10) <= 7)) {
                $(".chzn-select").chosen({
                    disable_search_threshold: 8,
                    drop_down_width: true,
                    inherit_select_classes: true,
                    disable_search: true
                }).change(function(){ if(typeof api  != 'undefined') api.reinitialise();});
                $('.chzn-search').hide();
            }

            if(! /Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent))
                $(".chzn-container, .chzn-select").hover(function () { $(this).mousedown().mouseup() }, function () { $('body').click() });

            var refreshIntervalId = false;
            var height = $(window).height()-109;

            $(".sidebar .items").css("height",height+"px");
            $('.scroll-pane').jScrollPane({
                showArrows: false,
                autoReinitialise: true,
                verticalDragMinHeight: 28,
                verticalDragMaxHeight: 28
            });
			var resizeTimeout;
            $(window).resize(function() {
                var height = $(window).height()-109;
                var wh = $(window).height();
                $(".sidebar .items").css("height",height+"px");

				if (resizeTimeout)
					clearTimeout(resizeTimeout);
				resizeTimeout = setTimeout(function(){
					Reload();
				}, 500);
            });


            $( "#slider-vertical" ).slider({
                orientation: "vertical",
                range: "min",
                min: 0,
                max: 100,
                value: 0,
                slide: function( event, ui ) {
                    //ui.value
                }
            });

            $(".arrow.down").mousedown(function(){
                refreshIntervalId = setInterval(SlideDown, 1);
            }).mouseup(function(){
                clearInterval(refreshIntervalId);
            });

            $(".arrow.top").mousedown(function(){
                refreshIntervalId = setInterval(SlideUp, 1);
            }).mouseup(function(){
                clearInterval(refreshIntervalId);
            });

			$('#layout').change(function(){
				var v = $(this).find('option:selected').val();
				change_layout(v);
			});

			$('#overlay').change(function(){
				var v = $(this).find('option:selected').val();
				change_overlay(v);
			});

			$('#action').change(function(){
	            var v = $(this).find('option:selected').val();
				/*if (v == '.')	$("#action-label").hide();
				else $("#action-label").show();*/
				change_action(v);
			});

			$('#preset').change(function(){
				var v = $(this).find('option:selected').val();
				return preset_voi(v);
			});

			$('#zoom').change(function(){
				var v = $(this).find('option:selected').val();
				zoom_changed(v);
			});


			$(".control-bar").css('width',$(".x-ray").width()+"px");

			var sliderBoxParentPrevent = false;

			$("#SLIDER-BOX").mousedown(function(e){
				var py = e.pageY;
				var top = parseFloat($("#SLIDER-BOX").css('margin-top'));
				var imageHeight = <%=kStripWidth%>;
				$(document).bind('mousemove', function(evt){
					sliderBoxParentPrevent=true;
					var pos = (top+evt.pageY-py);
					var index = Math.round(pos / imageHeight);
					if (index < 0) index = 0;
					if (index > <%=(NumImages - LayoutTable.layout.num_images)%>)
						index = <%=(NumImages - LayoutTable.layout.num_images)%>;
					pos = index * imageHeight;
					$("#SLIDER-BOX").css('margin-top', pos+"px");
				});
				$(document).bind('mouseup', function(evt){
					$(document).unbind('mousemove').unbind('mouseup');
					var pos = parseFloat($("#SLIDER-BOX").css('margin-top'));
					var index = Math.round(pos / imageHeight);
					JumpTo(index);
				})
			});

			$("#SLIDER-BOX").closest('td').mouseup(function(e){
				if (sliderBoxParentPrevent)
				{
					sliderBoxParentPrevent=false;
					return;
				}
				var imageHeight = <%=kStripWidth%>;
				var parent = $("#SLIDER-BOX").parent();
				var pos = parseFloat(e.pageY-parent.offset().top);
				var index = Math.floor(pos / imageHeight);
				if (index >= 0 && index <= <%=(NumImages - LayoutTable.layout.num_images)%>)
					JumpTo(index);
			});



			/*
			$('#order').change(function(){
				var v = $(this).find('option:selected').val();
				change_order(v);
			});
			*/

			// Commented because of FAS-62: When user selects any layout and then opens layout list, selected layout doesn’t highlight.
			//$("#layout_chzn, #overlay_chzn, #order_chzn, #action_chzn, #preset_chzn, #zoom_chzn").find('.result-selected').hide().remove();


			//$('#ANN-WRAPPER img').mousedown(onImageMouseDown);
        });

        function SlideDown() {
            var selection = $( "#slider-vertical" ).slider( "value" ) - 1;
            $( "#slider-vertical" ).slider( "value", selection );
        }
        function SlideUp() {
            var selection = $( "#slider-vertical" ).slider( "value" ) + 1;
            $( "#slider-vertical" ).slider( "value", selection );
        }

    </script>
<SCRIPT LANGUAGE="JavaScript1.2">
//----------------------------------------------------------------------------------------
// Viewer independed code
//----------------------------------------------------------------------------------------
//------------------------------
//
//------------------------------
function prettyTime(time) {
	var str = new String(time);
	return str.substr(0, 2) + ':' + str.substr(2, 2) + ':' + str.substr(4, 4);
}

//------------------------------
// Image Object
//------------------------------
function IR(file, imageNumber, imageDate, imageTime, rows, cols, xs, ys, x, y, z, xd, yd, wc, ww) {
	this.file = file;
	this.number = imageNumber;
	this.date = imageDate;
	this.time = imageTime;
	this.rows = rows;
	this.cols = cols;
	this.xs = xs;
	this.ys = ys;
	this.x = x;
	this.y = y;
	this.z = z;
	this.xd = xd;
	this.yd = yd;
	this.wc = wc;
	this.ww = ww;
}

//------------------------------
//
//------------------------------
IR.prototype.uri = function() {
	return '/DIOWave/scripts/dio-image.dll'
	     + '<%=config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + QSV.volume + "\"]/location").InnerText%>'
	     + '/'
	     + '<%=QSV.path%>'
	     + '/'
	     + this.file;
}

//------------------------------
// ImageBox
//------------------------------
function ImageBox(img, index) {
	this.img = img;
	this.index = index;
	this.loaded = true;
}
//------------------------------
//
//------------------------------
ImageBox.prototype.reload = function() {
	this.img.src = IDS.image_src(this.index, false);
}

//------------------------------
//
//------------------------------
ImageBox.prototype.start_track_update = function() {
	this.img.onload = onImageLoad;
	this.loaded = true;
}

//------------------------------
//
//------------------------------
ImageBox.prototype.track_update = function(nocache) {
	if (this.loaded) {
		this.loaded = false;
		this.img.src = IDS.image_src(this.index, nocache);
	}
}

//------------------------------
//
//------------------------------
ImageBox.prototype.end_track_update = function() {
	this.img.onload = null;
}

//------------------------------
//
//------------------------------
ImageBox.prototype.set_annotation = function() {
	set_annotation1(IDS.overlay, this.index);
}

//------------------------------
//
//------------------------------
function onActionMouseDown(e, action) {
	// close all chosen selects
	if (jQuery(".chzn-container-active").length > 0) {
		$("body").click();
		return true;
	}

	e = e.originalEvent || e || window.event;

	if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey)
		return true;

	CurrentAction = action;
	CurrentAction.mousedown(e);
	CurrentAction.begin_drag(e);

	$(document).bind('mousemove', onDocumentMouseMove)
			   .bind('mouseup', onDocumentMouseUp)
			   .bind('touchmove', onDocumentMouseMove)
			   .bind('touchend', onDocumentMouseUp);

	return false;
}
//------------------------------
//
//------------------------------

function onActionMouseWheel(e, delta, action) {
	CurrentAction = action;
	CurrentAction.mousewheel(e, delta);

	return false;
}

//------------------------------
//
//------------------------------
function onDocumentMouseUp(e) {
	if (CurrentAction != null) {
		CurrentAction.end_drag(e);
		CurrentAction = null;
	}

	$(document).unbind('mousemove')
			   .unbind('mouseup')
			   .unbind('touchmove')
			   .unbind('touchend');

	return false;
}

//------------------------------
//
//------------------------------
function onDocumentMouseMove(e) {
	if (CurrentAction != null)
		CurrentAction.do_drag(e);

	return false;
}

//------------------------------
// ImageActionObject
//------------------------------
function ImageActionObject() {
	this.md_imageX = -1;
	this.md_imageY = -1;
	this.md_pageX = -1;
	this.md_pageY = -1;

	this.mode = '.';

	this.anchor_x = -1;
	this.anchor_y = -1;
	this.anchor_X = -1;
	this.anchor_Y = -1;

	this.org_wc = -1;
	this.org_ww = -1;

	this.org_first_index = -1;

	this.box = null;
}

//------------------------------
//
//------------------------------
function ActionObject_mousedown(e) {
	var fixed_event = jQuery.event.fix(e),
		data = e.touches ? e.touches[0] : fixed_event,
		$target = jQuery(fixed_event.currentTarget || fixed_event.target),
		img_offset = ($target.is("td") ? $target : $target.closest(".IMG-CONTAINER")).find("img[name^='IMG-']").offset();

	this.md_imageX = data.pageX - img_offset.left;
	this.md_imageY = data.pageY - img_offset.top;
	this.md_pageX = data.pageX;
	this.md_pageY = data.pageY;
}
//------------------------------
ImageActionObject.prototype.mousedown = ActionObject_mousedown;

//------------------------------
//
//------------------------------
function ActionObject_mousewheel(e, delta) {
	if (this.mode=='P')
	{
		Jump(delta<0 ? 1 : -1);
	}
}
//------------------------------
ImageActionObject.prototype.mousewheel = ActionObject_mousewheel;

//------------------------------
//
//------------------------------
function ActionObject_x(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return this.md_imageX + data.pageX - this.md_pageX;
}
//------------------------------
ImageActionObject.prototype.x = ActionObject_x;

//------------------------------
//
//------------------------------
function ActionObject_y(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return this.md_imageY + data.pageY - this.md_pageY;
}
//------------------------------
ImageActionObject.prototype.y = ActionObject_y;

//------------------------------
//
//------------------------------
function ActionObject_offset_x(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return data.pageX - this.md_pageX;
}
//------------------------------
ImageActionObject.prototype.offset_x = ActionObject_offset_x;

//------------------------------
//
//------------------------------
function ActionObject_offset_y(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return data.pageY - this.md_pageY;
}
//------------------------------
ImageActionObject.prototype.offset_y = ActionObject_offset_y;

//------------------------------
//
//------------------------------
function onImageMouseDown(e) {
	//alert(1);
	return onActionMouseDown(e, ImageAction);
}

function onImageMouseWheel(e, delta) {
	return onActionMouseWheel(e, delta, ImageAction);
}

//------------------------------
//
//------------------------------
function SetVarText(id, val) {
	$('#' + id).text(val);
}

//------------------------------
//
//------------------------------
function setVOIText() {
	var wc = IDS.wc;
	var ww = IDS.ww;
	if (wc == 0 && ww == 0) {
		wc = "";
		ww = "";
	}
	$('#preset-l').html(wc);
	$('#preset-w').html(ww);
}

//------------------------------
//
//------------------------------
function change_action(arg) {
	if (IDS.action == arg)
		return;
	IDS.action = arg;
	setActionText();
	setup_action(arg);
//	ping("ACTION=" +  arg);
}

//------------------------------
//
//------------------------------
function change_overlay(arg) {
	if (IDS.overlay == arg)
		return;
	IDS.overlay = arg;
	setup_annotations(arg);
//	ping("OVERLAY=" +  arg);
}

//------------------------------
//
//------------------------------
function show_series_detail() {
	var div = $('#SeriesDetail');
	div.toggle().css('bottom', '0px');
}

//----------------------------------------------------------------------------------------
</SCRIPT>
<SCRIPT LANGUAGE="JavaScript1.2">
//----------------------------------------------------------------------------------------
// Viewer dependant code
//----------------------------------------------------------------------------------------

//------------------------------
//
//------------------------------
var image_orientation_table = "<%=ImageObject.image_orientation_table%>";

//------------------------------
//
//------------------------------
IR.prototype.make_measure_table = function(key, anntext, return_empty) {
	//------------------------------
	//
	//------------------------------
	function select_measure_unit(pixel_spacing, limit) {
		var real_len_list = new Array(1.0, 10.0, 100.0);
		var disp_len_list = new Array(0.0,  0.0,   0.0);
		for (var i = 0; i < real_len_list.length; i++) {
			var rlen = real_len_list[i];
			var dlen = rlen / pixel_spacing;
			if (dlen < 16)
				continue;
			if (dlen > limit)
				continue;
			disp_len_list[i] = dlen;
		}
		for (var i = 0; i < disp_len_list.length; i++) {
			var dlen = disp_len_list[i];
			if (dlen != 0.0)
				return dlen;
		}
		return 0;
	}

	var scale = IDS.zoom * <%=LayoutTable.layout.scale%>;
	var ps, limit;
	switch (key) {
	case 'BC':
		ps = this.xs / scale;
		limit = <%=LayoutTable.layout.width * 2 / 3%>;
		break;
	case 'MR':
		ps = this.ys / scale;
		limit = <%=LayoutTable.layout.height * 2 / 3%>;
		break;
	}

	var unit = select_measure_unit(ps, limit);
	if (unit == 0)
	{
		if (return_empty!==false)
			return anntext;
		else
			return '';
	}

	var count = Math.floor(limit / unit);
	if (count > 10)
		count = 10;

	var size = Math.ceil(unit * count);

	var html;
	switch (key) {
	case 'BC':
		html = '<table style="position:absolute;height:24px;top:<%=LayoutTable.layout.height - 24%>px;left:' + Math.floor((<%=LayoutTable.layout.width%> - size) / 2) + 'px;width:' + size + 'px;border-collapse:collapse;" cellpadding="0" cellspacing="0" cols="' + count + '" rows="2">';
		html += '<tr style="height:5px;">';
		var last_x = 0;
		for (var i = 0; i < count; i++) {
			var x = Math.floor((i + 1) * unit + 0.5);
			var width = x - last_x - 1;
			last_x = x;
			html += '<td style="width:' + width + 'px;';
			if (i == 0)
				html += 'border-left:1px solid #FFAA00;'
			html += 'border-right:1px solid #FFAA00;"></td>';
		}
		html += '</tr>';
		html += '<tr><td class="ANNTEXT" colspan="' + count + '" align="center" valign="top" style="border-top:1px solid #FFAA00;text-align:center;">';
		html += anntext;
		html += '</td></tr>';
		break;

	case 'MR':
		html = '<table style="position:absolute;height:' + size + 'px;top:' + Math.floor((<%=LayoutTable.layout.height%> - size) / 2) + 'px;left:<%=LayoutTable.layout.width - 16%>px;border-collapse:collapse;" cellpadding="0" cellspacing="0" rows="' + count + '" cols="2">';
		var last_y = 0;
		for (var i = 0; i < count; i++) {
			var y = Math.floor((i + 1) * unit + 0.5);
			var height = y - last_y;
			last_y = y;
			if (i == count - 1)
				height++;
			html += '<tr style="height:' + height + 'px;">';
			html += '<td style="width:5;border-top:1px solid #FFAA00;';
			if (i == count - 1)
				html += 'border-bottom:1px solid #FFAA00;';
			html += '">&nbsp;</td>';
			if (i == 0) {
				html += '<td class="ANNTEXT" rowspan="' + count + '" align="left" valign="middle" style="border-left:1px solid #FFAA00;vertical-align:middle;">';
				html += anntext;
				html += '</td>';
			}
			html += '</tr>';
		}
		break;
	}

	return html + '</table>';

}
//------------------------------
//
//------------------------------
IR.prototype.put_annotation = function(flag, index) {
	var html = "";
	if (flag == 'N') {
		var TL = '<DIV STYLE="position:absolute;top:0px;left:0px;" CLASS="ANNTEXT">';
		TL += this.number;
		TL += '<DIV>';
		html = TL;
	} else if (flag == 'D') {

		var TL = '<DIV STYLE="position:absolute;top:0;left:0;" CLASS="ANNTEXT">';
		TL += 'No: ' + this.number + '<BR>';
		if (this.xd != 0 && this.yd != 0 && this.xd != 5 && this.yd != 5 && this.xd != 6 && this.yd != 6)
			TL += 'Ax: ' + (this.z < 0 ? 'F' : (this.z > 0 ? 'H' : '')) + (Math.floor(Math.abs(this.z) * 10 + 0.5) / 10);
		else if (this.xd != 0 && this.yd != 0 && this.xd != 3 && this.yd != 3 && this.xd != 4 && this.yd != 4)
			TL += 'Cr: ' + (this.y < 0 ? 'A' : (this.y > 0 ? 'P' : '')) + (Math.floor(Math.abs(this.y) * 10 + 0.5) / 10);
		else if (this.xd != 0 && this.yd != 0 && this.xd != 1 && this.yd != 1 && this.xd != 2 && this.yd != 2)
			TL += 'Sg: ' + (this.x < 0 ? 'L' : (this.x > 0 ? 'R' : '')) + (Math.floor(Math.abs(this.x) * 10 + 0.5) / 10);
		var fovx = 0, fovy = 0;
		if (IDS.zoom == 1.0) {
			fovx = Math.floor(this.cols * this.xs + 0.5);
			fovy = Math.floor(this.rows * this.ys + 0.5);
		} else {
			fovx = Math.floor(this.cols * this.xs / IDS.zoom + 0.5);
			fovy = Math.floor(this.rows * this.ys / IDS.zoom + 0.5);
		}
		if (fovx != 0 && fovy != 0)
			TL += '<BR>FOV: ' + fovx + 'x' + fovy;
		TL += '</DIV>';

		//top center
		var TC = '<DIV style="position:absolute;top:0;left:<%=Math.Floor(Convert.ToDouble(LayoutTable.layout.width / 2 - 8))%>px;width:16px;text-align:center;" CLASS="ANNTEXT">';
		TC += image_orientation_table.charAt(this.yd * 2);
		TC += '</DIV>';

		//top right
		var TR = '';
		if (this.time != 0) {
			TR = '<div style="position:absolute;top:0px;right: 0px;text-align:right;padding-right:3px;" CLASS="ANNTEXT">';
			TR += 'Tm: ' + prettyTime(this.time);
			TR += '</div>';
		}

		//middle left
		var ML = '<TABLE style="position:absolute;top:<%=Math.Floor(Convert.ToDouble(LayoutTable.layout.height / 2 - 16))%>px;height:32px;left:0px;"><tr><td valign="middle" align="left" CLASS="ANNTEXT">';
		ML += image_orientation_table.charAt(this.xd * 2);
		ML += '</td></tr></TABLE>';

		//bottom left
		var BL = "";
		if (IDS.wc == 0 && IDS.ww == 0) {
			BL = '<TABLE BORDER="0" CELLSPACING="0" CELLPADDING="0" STYLE="position:absolute;top:<%=(LayoutTable.layout.height - 48)%>px;left:0px;height:48px;"><tr><td valign="bottom" align="left" CLASS="ANNTEXT">';
			BL += 'L: ' + this.wc + '<BR>W: ' + this.ww;
			BL += '</td</tr></TABLE>';
		}

		var MR = this.make_measure_table('MR', image_orientation_table.charAt(this.xd * 2 + 1), false);

		var BC = this.make_measure_table('BC', image_orientation_table.charAt(this.yd * 2 + 1), false);

		html = TL + TC + TR + ML + MR + BC + BL;

	}
	$('#ANN-' + index).html(html);
}

//------------------------------
//
//------------------------------
function findFirstImageIndex() {
<% if (LayoutTable.noscroll) { %>
	return 0;
<% } else if (QSV.first_index >= 0) { %>
	return <%=QSV.first_index%>;
<% } else { %>
	return 0;
<% } %>
}

//------------------------------
// ImageDisplaySetting
//------------------------------
function ImageDisplaySetting() {

	// Zoom
	this.zoom = <%=QSV.zoom%>;
	this.zx = <%=(QSV.zx < 0 ? get_data_US(null, DOM, 0x00280011, 0) / 2 : QSV.zx)%>;
	this.zy = <%=(QSV.zy < 0 ? get_data_US(null, DOM, 0x00280010, 0) / 2 : QSV.zy)%>;

	// VOI
	this.wc = <%=VOITable.wc%>;
	this.ww = <%=VOITable.ww%>;

	// Display Range
	this.first_index = findFirstImageIndex();

	// mode
	this.overlay = '<%=QSV.overlay%>';
	this.action = '<%=QSV.action%>';

	this.fit = '<%=QSV.fit%>';
	this.order = '<%=QSV.order%>';

	this.layout_rows = <%=LayoutTable.layout.rows%>;
	this.layout_cols = <%=LayoutTable.layout.cols%>;
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.query_string = function() {
	return '&VOI=' + escape('' + this.wc + ',' + this.ww)
	     + '&FI=' + this.first_index
	     + (this.zoom > 1 ? '&ZOOM=' + this.zoom + '&ZX=' + this.zx + '&ZY=' + this.zy : '')
	     + '&FIT=' + escape(this.fit)
	     + '&ORDER=' + escape(IDS.order)
	     + '&LAYOUT=' + escape(IDS.layout_rows + ',' + IDS.layout_cols)
	     + '&ACTION=' + escape(IDS.action)
	     + '&OVERLAY=' + escape(IDS.overlay);
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.image_src = function(index, nocache) {
	index += this.first_index;
	if (index >= IL.length)
		return '/DIOWave/bbox.gif';
	return IL[index].uri()
		+ '?WC=' + this.wc
		+ '&WW=' + this.ww
		+ '&HEIGHT=<%=LayoutTable.layout.height%>'
		+ '&WIDTH=<%=LayoutTable.layout.width%>'
		+ (this.zoom != 1.0 ? '&SCALE=' + (this.zoom * <%=LayoutTable.layout.scale%>) + '&ZX=' + this.zx + '&ZY=' + this.zy : '')
		+ (nocache ? '&CACHE=2' : '');
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.icon_src = function(index) {
	return IL[index].uri()
		+ '?WIDTH=<%=kStripWidth%>'
		+ '&HEIGHT=<%=kStripWidth%>'
		<%=(update_icon ? " + '&WC=' + this.wc + '&WW=' + this.ww" : "")%>;
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_first_index = function(index) {
	if (index < 0)
		index = 0;
	else if (index > <%=(NumImages - LayoutTable.layout.num_images)%>)
		index = <%=(NumImages - LayoutTable.layout.num_images)%>;

	var r = index != this.first_index;
	if (r)
		this.first_index = index;

	return r;
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_zoom_center = function(x, y, anchor_x, anchor_y, anchor_X, anchor_Y) {
<%/*
	X2: �ړ���̃}�E�X�̉��ɂȂ�|�C���g�̃I���W�i���摜��ł̍��W
	x2: �ړ���̃}�E�X�̉��ɂȂ�|�C���g�̕\����̍��W
	C2: �ړ���̕\����̒��S�ɂȂ�|�C���g�̃I���W�i���摜��̂ł̍��W
	c2: �ړ���̕\����̒��S���W

	X1: �ړ��O�̃}�E�X�̉��ɂ���|�C���g�̃I���W�i���摜��̍��W
	x1: �ړ��O�̃}�E�X�̉��ɂ���|�C���g�̕\����̍��W
	C1: �ړ��O�̕\����̒��S�̃|�C���g�̃I���W�i���摜��ł̍��W
	c1: �ړ��O�̕\����̒��S���W

	S: �X�P�[��

	X2 = X1 = X
	c2 = c1 = c

	(X2 - C2) * S = x2 - c2
	(X2 - C1) * S = x1 - c2

	(X - C2) * S = x2 - c
	(X - C1) * S = x1 - c

	C2 = (x1 - x2)/S + C1

*/%>
	var S = <%=LayoutTable.layout.scale%> * this.zoom;

	this.zx = Math.floor((anchor_x - x)/S + anchor_X);
	this.zy = Math.floor((anchor_y - y)/S + anchor_Y);

	this.adjust_zoom_center();
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_zoom_center2 = function(x, y, zoom) {
<%/*
	X2: �Y�[����̃}�E�X�̉��ɂȂ�|�C���g�̃I���W�i���摜��ł̍��W
	x2: �Y�[����̃}�E�X�̉��ɂȂ�|�C���g�̕\����̍��W
	C2: �Y�[����̕\����̒��S�ɂȂ�|�C���g�̃I���W�i���摜��̂ł̍��W
	c2: �Y�[����̕\����̒��S���W
	S2: �Y�[����̃X�P�[��

	X1: �Y�[���O�̃}�E�X�̉��ɂ���|�C���g�̃I���W�i���摜��̍��W
	x1: �Y�[���O�̃}�E�X�̉��ɂ���|�C���g�̕\����̍��W
	C1: �Y�[���O�̕\����̒��S�̃|�C���g�̃I���W�i���摜��ł̍��W
	c1: �Y�[���O�̕\����̒��S���W
	S1: �Y�[���O�̃X�P�[��


	(X1 - C1) * S1 = (x1 - c1)
	(X2 - C2) * S2 = (x2 - c2)

	c1 = c2 = c
	x1 = x2 = x
	X1 = X2 = X

	(X - C1) * S1 = x - c
	(X - C2) * S2 = x - c

	X = (x - c) / S1 + C1
	  = (x - c) / S2 + C2

	C2 = C1 + (x - c)/S1 - (x - c)/S2
*/%>
	var cx = <%=LayoutTable.layout.width%> / 2;
	var cy = <%=LayoutTable.layout.height%> / 2;
	var Cx = <%=get_data_US(null, DOM, 0x00280011, 0)%> / 2;
	var Cy = <%=get_data_US(null, DOM, 0x00280010, 0)%> / 2;
	var S1 = <%=LayoutTable.layout.scale%> * this.zoom;
	var S2 = <%=LayoutTable.layout.scale%> * zoom;

	this.zx = Math.floor(Cx + (x - cx)/S1 - (x - cx)/S2);
	this.zy = Math.floor(Cy + (y - cy)/S1 - (y - cy)/S2);

	this.zoom = zoom;

	this.adjust_zoom_center();
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.adjust_zoom_center = function() {
	var scale = <%=LayoutTable.layout.scale%> * this.zoom;

	var halfX = Math.floor(<%=LayoutTable.layout.width%> / scale / 2);
	var halfY = Math.floor(<%=LayoutTable.layout.height%> / scale / 2);

	if (this.zx < halfX)
		this.zx = halfX;
	else if (this.zx > <%=get_data_US(null, DOM, 0x00280011, 0)%> - halfX)
		this.zx = <%=get_data_US(null, DOM, 0x00280011, 0)%> - halfX;

	if (this.zy < halfY)
		this.zy = halfY;
	else if (this.zy > <%=get_data_US(null, DOM, 0x00280010, 0)%> - halfY)
		this.zy = <%=get_data_US(null, DOM, 0x00280010, 0)%> - halfY;
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_drag_voi = function(orgWC, orgWW, x, y) {
	var ax = Math.abs(x);
	if (ax <= 4)
		ax = 0;
	else
		ax -= 4;
	x = x < 0 ? -ax : ax;

	var ay = Math.abs(y);
	if (ay <= 4)
		ay = 0;
	else
		ay -= 4;
	y = y < 0 ? -ay : ay;

	if (ax == 0 && ay == 0)
		return;

	var tan30 = 0.57735;
	if (ax != 0 && ay / ax < tan30) {
		this.ww = Math.floor(orgWW * Math.pow(2, x / 128));
	} else if (ay != 0 && ax / ay < tan30) {
		this.wc = orgWC + Math.floor(ay * y * orgWW / 32768);
	} else {
		this.ww = Math.floor(orgWW * Math.pow(2, x / 128));
		this.wc = orgWC + Math.floor(ay * y * orgWW / 32768);
	}
}


//------------------------------
// SliderActionObject
//------------------------------
function SliderActionObject() {
	this.md_imageX = -1;
	this.md_imageY = -1;
	this.md_pageX = -1;
	this.md_pageY = -1;

	this.box = null;
	this.indicator = null;
	this.panel_top = 0;
	this.grip_offset = 0;
}

//------------------------------
SliderActionObject.prototype.mousedown = ActionObject_mousedown;
SliderActionObject.prototype.x = ActionObject_x;
SliderActionObject.prototype.y = ActionObject_y;
SliderActionObject.prototype.offset_x = ActionObject_offset_x;
SliderActionObject.prototype.offset_y = ActionObject_offset_y;
SliderActionObject.prototype.mousewheel = ActionObject_mousewheel;

//------------------------------
//
//------------------------------
ImageActionObject.prototype.begin_drag = function(e) {
	var fixed_event = jQuery.event.fix(e);

	this.box = (fixed_event.currentTarget || fixed_event.target).box;

	this.box.start_track_update();

	if (this.mode == 'Z') {
		var x = this.x(e);
		var y = this.y(e);
		if (IDS.zoom == 1) {
			IDS.set_zoom_center2(x, y, 2);
			this.box.track_update(true);
			setZoomText();
			reload_annotation_text();
		}
		this.anchor_x = x;
		this.anchor_y = y;
		this.anchor_X = IDS.zx;
		this.anchor_Y = IDS.zy;
	} else if (this.mode == 'V') {
		if (IDS.wc == 0 && IDS.ww == 0) {
			var img = IL[IDS.first_index + this.box.index];
			IDS.wc = img.wc;
			IDS.ww = img.ww;
			setVOIText();
		}
		this.org_wc = IDS.wc;
		this.org_ww = IDS.ww;
	} else if (this.mode == 'P') {
<% if (!LayoutTable.noscroll) { %>
		this.org_first_index = IDS.first_index;
<% } %>
	}
}
//------------------------------
//
//------------------------------
function eventIsTouch(e) {
	return e.touches ? true : false;
}

//------------------------------
//
//------------------------------
ImageActionObject.prototype.do_drag = function(e) {
	if (e.originalEvent) e = e.originalEvent;
	if (this.mode == 'Z') {
		var x = IDS.zx;
		var y = IDS.zy;
		IDS.set_zoom_center(this.x(e), this.y(e), this.anchor_x, this.anchor_y, this.anchor_X, this.anchor_Y);
		if (IDS.zx != x || IDS.zy != y)
			this.box.track_update(true);
	} else if (this.mode == 'V') {
		var wc = IDS.wc;
		var ww = IDS.ww;
		var ox = this.offset_x(e);
		var oy = this.offset_y(e);
		if (eventIsTouch(e))
		{
			ox = ox * <%=VOITable.wc%> / window.screen.width;
			oy = oy * <%=VOITable.ww%> / window.screen.height;
		}
		IDS.set_drag_voi(this.org_wc, this.org_ww, ox, oy);
		if (IDS.wc != wc || IDS.ww != ww) {
			this.box.track_update(true);
			setVOIText();
		}
	} else if (this.mode == 'P') {
<% if (!LayoutTable.noscroll) { %>
		var index = this.org_first_index + Math.floor(this.offset_y(e) / 16);
		if (IDS.set_first_index(index)) {
			this.box.track_update(false);
			this.box.set_annotation();
			SliderAction.set_indicator();
			update_slider_box(index);
		}
<% } %>
	}
}

//------------------------------
//
//------------------------------

function iao_pagexy_available(e)
{
	return !eventIsTouch(e) || e.touches.length > 0;
}

ImageActionObject.prototype.end_drag = function(e) {
	if (e.originalEvent) e = e.originalEvent;
	if (this.mode == 'Z') {
		if (iao_pagexy_available(e))
			IDS.set_zoom_center(this.x(e), this.y(e), this.anchor_x, this.anchor_y, this.anchor_X, this.anchor_Y);
		reload_imgbox(ImageBoxTable);
	} else if (this.mode == 'V') {
		if (iao_pagexy_available(e)) {
			var ox = this.offset_x(e);
			var oy = this.offset_y(e);
			if (eventIsTouch(e))
			{
				ox = ox * <%=VOITable.wc%> / window.screen.width;
				oy = oy * <%=VOITable.ww%> / window.screen.height;
			}
			IDS.set_drag_voi(this.org_wc, this.org_ww, ox, oy);
		}
		reload_imgbox(ImageBoxTable);
		reload_annotation_text();
		<%=(update_icon ? "reload_imgbox(IconBoxTable);" : "")%>
		setVOIText();
	} else if (this.mode == 'P') {
<% if (!LayoutTable.noscroll) { %>
		if (iao_pagexy_available(e)) {
			var index = this.org_first_index + Math.floor(this.offset_y(e) / 16);
			if (IDS.set_first_index(index))
				this.set_indicator();
		}
		reload_imgbox(ImageBoxTable);
		reload_annotation_text();
<% } %>
	}

	this.box.end_track_update();
}

//------------------------------
//
//------------------------------
ImageActionObject.prototype.dblclick = function(e) {
	if (e.originalEvent) e = e.originalEvent;

	if (IDS.layout_rows == 1 && IDS.layout_cols == 1)
		return;

	var fixed_event = jQuery.event.fix(e);

	this.box = (fixed_event.currentTarget || fixed_event.target).box;

	IDS.first_index += this.box.index;

	IDS.layout_rows = 1;
	IDS.layout_cols = 1;

	Reload();
}

//------------------------------
//
//------------------------------
SliderActionObject.prototype.calc_index = function(y) {
	return Math.floor((y - this.grip_offset) / <%=SliderPanel.ind_step%>);
}

//------------------------------
//
//------------------------------
SliderActionObject.prototype.begin_drag = function(e) {
<% if (LayoutTable.noscroll) { %>
	return;
<% } %>
	for (var i in ImageBoxTable)
		ImageBoxTable[i].start_track_update();

	var y = this.y(e);

	var slider_top = Math.floor(<%=SliderPanel.ind_step%> * IDS.first_index);
	var slider_bottom = slider_top + <%=SliderPanel.ind_height%>;
	if (y >= slider_top && y < slider_bottom) {
		this.grip_offset = y - slider_top;
	} else {
		this.grip_offset = <%=(SliderPanel.ind_height / 2)%>;
		var index = this.calc_index(y);
		if (IDS.set_first_index(index)) {
			for (var i in ImageBoxTable) {
				var box = ImageBoxTable[i];
				box.track_update(false);
				box.set_annotation();
			}
			this.set_indicator();
		}
	}
}

//------------------------------
//
//------------------------------
SliderActionObject.prototype.do_drag = function(e) {
<% if (LayoutTable.noscroll) { %>
	return;
<% } %>
	var index = this.calc_index(this.y(e));
	if (IDS.set_first_index(index)) {
		for (var i in ImageBoxTable) {
			var box = ImageBoxTable[i];
			box.track_update(false);
			box.set_annotation();
		}
		this.set_indicator();
	}
}

//------------------------------
//
//------------------------------
SliderActionObject.prototype.end_drag = function(e) {
<% if (LayoutTable.noscroll) { %>
	return;
<% } %>
	if (this.offset_x(e) == 0 && this.offset_y(e) == 0) {
		for (var i in ImageBoxTable) {
			ImageBoxTable[i].end_track_update();
		}
	} else {
		var index = this.calc_index(this.y(e));
		if (IDS.set_first_index(index)) {
			for (var i in ImageBoxTable) {
				var box = ImageBoxTable[i];
				box.track_update(false);
				box.set_annotation();
				box.end_track_update();
			}
			this.set_indicator();
		}
	}
}

//------------------------------
//
//------------------------------
SliderActionObject.prototype.set_indicator = function() {
	if (this.indicator)
	{
	<% if (NumImages > 1) { %>
		var top = this.panel_top + Math.floor(<%=SliderPanel.ind_step%> * IDS.first_index);

		if (typeof this.indicator.style.pixelTop != 'undefined')
			this.indicator.style.pixelTop = top;
		else
			this.indicator.style.top = top + 'px';
	<% } %>
	}
}

//------------------------------
// IconBox
//------------------------------
function IconBox(img, index) {
	this.img = img;
	this.index = index;
}
//------------------------------
//
//------------------------------
IconBox.prototype.reload = function() {
	this.img.src = IDS.icon_src(this.index);
}

//------------------------------
//
//------------------------------
function reload_imgbox(table) {
	for (var i in table) {
		var box = table[i];
		box.reload();
	}
}

//------------------------------
//
//------------------------------
function setup_imgboxes() {
	for (var i = 0; i < document.images.length; i++) {
		var img = document.images[i];
		var name = img.name;
		if (name.indexOf('IMG-') == 0) {
			var index = name.substring(4);
			var box = new ImageBox(img, parseInt(index));
			ImageBoxTable[index] = box;
			img.box = box;

			var assign_box = function () { this.box = box };

			jQuery("#ACT-" + index + ", #ACTTD-" + index).each(assign_box);
			jQuery("#ACT-" + index).closest("td").each(assign_box);
		}
		else if (name.indexOf('ICN-') == 0) {
			var index = name.substring(4);
			var box = new IconBox(img, parseInt(index));
			IconBoxTable[IconBoxTable.length] = box;
			img.box = box;
		}
	}
}


//------------------------------
//
//------------------------------
function setup_sliderpanel() {
	var div = jQuery("#SLIDER-ACT")[0];

	if (div) {
		$(div).bind('mousedown', onSliderMouseDown)
			  .bind('touchstart', onSliderMouseDown)
			  .closest('td')
			   .bind('mousewheel', onSliderMouseWheel);
		//div.onmousedown = onSliderMouseDown;
		div.style.visibility = 'visible';
		div = jQuery("#SLIDER-IND")[0];
		div.style.visibility = 'visible';
		SliderAction.indicator = div;
		SliderAction.panel_top = div.offsetTop;
	}
}

//------------------------------
//
//------------------------------
function set_annotation1(flag, index) {
	var id = '#' + 'ANN-' + index;
	if (flag == '.') {
		$(id).hide();
	} else {
		var img = IL[index+IDS.first_index];
		img.put_annotation(flag, index);
		$(id).show();
		}
	}

//------------------------------
//
//------------------------------
function setup_annotations(flag) {
	for (var i = 0; i < <%=LayoutTable.layout.num_images%>; i++)
		set_annotation1(flag, i);
}

//------------------------------
//
//------------------------------
function reload_annotation_text() {
	setup_annotations(IDS.overlay);
}

//------------------------------
//
//------------------------------
function setup_action(flag) {
	for (var i = 0; i < <%=LayoutTable.layout.num_images%>; i++) {
		var div = jQuery("#ACT-" + i)[0];
		if ( !div ) continue;
		$(div).closest('td')
			.unbind('dblclick')
			.unbind('mousedown')
			.unbind('touchstart')
			.unbind('mousewheel');
		if (flag == '.') {
			div.style.visibility = 'hidden';
		} else {
			div.style.visibility = 'visible';
			$(div).closest('td')
				.bind('mousedown', onImageMouseDown)
				.bind('touchstart', onImageMouseDown)
				.bind('dblclick', onImageDblClick)
				.bind('mousewheel', onImageMouseWheel);
		}
	}
	ImageAction.mode = flag;
}

//------------------------------
//
//------------------------------
function Reload() {
	var ww =  parent.$('.main').width();
	var wh = parent.$('.main').height();
	var url = 'spatial-series-viewer.aspx'
	               + '?VOLUME=<%=QSV.volume%>'
	               + '&PATH=<%=QSV.path%>'
	               + '&SERIES=<%=QSV.series_uid%>'
	               + '&WW=' + ww
	               + '&WH=' + wh
	               + IDS.query_string();
	/*if (parent.reload_viewer)
		parent.reload_viewer(url);
	else*/
	location.replace(url);

	parent.resizeIframe();
}

//------------------------------
//
//------------------------------
function Jump(flag) {
	var index = IDS.first_index;
	switch (flag) {
	case -1:
		index -= <%=LayoutTable.layout.num_images%>;
		break;
	case 1:
		index += <%=LayoutTable.layout.num_images%>;
		break;
	}

	JumpTo(index);
}

//------------------------------
//
//------------------------------

function JumpTo(index) {
	if (IDS.set_first_index(index)) {
		reload_imgbox(ImageBoxTable);
		reload_annotation_text();
		SliderAction.set_indicator();
		update_slider_box(index);
	}
}

//------------------------------
//
//------------------------------

function update_slider_box(index) {
	var imageHeight = <%=kStripWidth%>;
	if (index<0) index=0;
	if (index > <%=(NumImages - LayoutTable.layout.num_images)%>)
		index = <%=(NumImages - LayoutTable.layout.num_images)%>;
	$("#SLIDER-BOX").css('margin-top', imageHeight*index);
}

//------------------------------
//
//------------------------------
function setActionText() {
	var str;
	switch (IDS.action) {
	case 'Z':
		// FAS-54: [Action] function of Menu Bar: the currently selected action is displayed as "Pan" instead of "Zoom" to the right of the Action menu_[win]
		/*if (IDS.zoom == 1)
			str = 'Zoom';
		else
			str = 'Pan';*/
		str = 'Zoom';
		break;
	case 'V':
		str = 'W/L';
		break;
	case 'P':
		str = 'Page';
		break;
	default:
		str = '';
		break;
	}
	$("#action option[value='"+IDS.action+"']").attr('selected', 'selected');
	//$('#action-label').text(str);
}
//------------------------------
//
//------------------------------
function setZoomText() {
	$('#zoom-label').html('X ' + IDS.zoom + ' (' + (Math.ceil(IDS.zoom * <%=LayoutTable.layout.scale%> * 1000) / 10) + '%)');
	setActionText();
}

//------------------------------
//
//------------------------------
function onSliderMouseDown(e) {
	return onActionMouseDown(e, SliderAction);
}

function onSliderMouseWheel(e, delta) {
	return onActionMouseWheel(e, delta, SliderAction);
}

//------------------------------
//
//------------------------------
function onImageDblClick(e) {
	e = e.originalEvent || e || window.event;

	if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey)
		return true;

	ImageAction.mousedown(e);
	ImageAction.dblclick(e);

	return false;
}

//------------------------------
//
//------------------------------
function onImageLoad(e) {
	e = e || window.event;
	var box = (e.currentTarget || e.target || e.srcElement).box;

	if (box != null)
		box.loaded = true;
}

//------------------------------
//
//------------------------------
if (!window.setOrderText)
{
	function setOrderText() {
		var str = '';
		var order = IDS.order.split(',');
		switch (order[0]) {
		case 'N':
			str = 'Num (' + (order[1] == 'A' ? 'N' : 'R') + ')';
			break;
		case 'T':
			str = 'Time (' + (order[1] == 'A' ? 'N' : 'R') + ')';
			break;
		case 'Z':
			str = 'Z (' + (order[1] == 'A' ? 'F-H' : 'H-F') + ')';
			break;
		case 'Y':
			str = 'Y (' + (order[1] == 'A' ? 'P-A' : 'A-P') + ')';
			break;
		case 'X':
			str = 'Y (' + (order[1] == 'A' ? 'L-R' : 'R-L') + ')';
			break;
		}

		SetVarText('ORDER', str);
	}
}

//------------------------------
//
//------------------------------
function onFirstLoad() {
//alert('begin onFirstLoad');
	setup_imgboxes();

	setVOIText();
	setZoomText();
	setOrderText();

	reload_imgbox(ImageBoxTable);
	reload_imgbox(IconBoxTable);
	//alert(1);
	reload_annotation_text();
	SliderAction.set_indicator();


	setup_sliderpanel();
	setup_action(IDS.action);

	//drmenu_init('L');
	//drmenu_init('S');
	//drmenu_init('O');
	//drmenu_init('V');
	//drmenu_init('Z');
	//drmenu_init('A');

	//SetupSeriesDetail();

	pingImage = document.getElementById("reload");

	window.onload = new Function("return false;");

	//alert('end onFirstLoad');

	return false;
}

//------------------------------
//
//------------------------------
function change_layout(arg) {
	if (arg.length == 0)
		return;

	if (arg.indexOf(',') < 0) {
		IDS.fit = arg;
		Reload();
		return;
	}

	if (IDS.fit == arg)
		return;

	var rc = arg.split(',');
	var r = parseInt(rc[0]);
	var c = parseInt(rc[1]);
	if (IDS.layout_rows == r && IDS.layout_cols == c)
		return;

	IDS.layout_rows = r;
	IDS.layout_cols = c;
	Reload();
}
//------------------------------
//
//------------------------------
function zoom_changed(arg) {
	arg = parseFloat(arg);
	if (IDS.zoom == arg)
		return;
	IDS.zoom = parseFloat(arg);
	setZoomText();
	reload_imgbox(ImageBoxTable);
	reload_annotation_text();
}

//------------------------------
//
//------------------------------
function preset_voi(arg) {
	if ( !arg ) return;
	var cw = arg.split(',');

	var wc = parseInt(cw[0]);
	var ww = parseInt(cw[1]);

	if (wc == -1 && ww == -1) {
		var str = prompt('Enter Desired Window Level / Window Width', IDS.wc + ' / ' + IDS.ww);
		if (str == null || str.length == 0)
			return false;
		var ary = str.match(/\s*(-?\d+)\s*\/\s*(\d+)\s*/);
		if (ary != null) {
			wc = parseInt(ary[1]);
			ww = parseInt(ary[2]);
		} else {
			ary = str.match(/\s*\/\s*(\d+)\s*/);
			if (ary != null) {
				wc = IDS.wc;
				ww = parseInt(ary[1]);
			} else {
				ary = str.match(/\s*(-?\d+)\s*/);
				if (ary != null) {
					wc = parseInt(ary[1]);
					ww = IDS.ww;
				} else {
					alert('Invalid Window Level/Window Width Entry');
					return false;
				}
			}
		}
	}

	if (IDS.wc == wc && IDS.ww == ww)
		return false;

	IDS.wc = wc;
	IDS.ww = ww;

	setVOIText(wc, ww);

	reload_imgbox(ImageBoxTable);
	reload_annotation_text();
	<%=(update_icon ? "reload_imgbox(IconBoxTable);" : "")%>
}

//------------------------------
//
//------------------------------
//function ping(arg) {
//    if (pingImage)
//        pingImage.src = "media/images/reload.png";
//}

//------------------------------
//
//------------------------------
<%printImageList(ImageList, ImageSpace);%>
var IDS = new ImageDisplaySetting();
var ImageBoxTable = new Array;
var IconBoxTable = new Array;
var ImageAction = new ImageActionObject();
var SliderAction = new SliderActionObject();
var CurrentAction = null;
var pingImage = null;

//----------------------------------------------------------------------------------------
</SCRIPT>
<STYLE TYPE="text/css">
/****************************************************************************************/

BODY {
	background-color: #040a18;
	color:white;
	font-size:10pt;

	border-width: 0 0 0 0;
<% if (m_browser.type == "NN" && m_browser.os == "M") { %>
	margin-left:-6;
	margin-top:-6;
	margin-right:0;
	margin-bottom:0;
<% } else { %>
	margin: 0 0 0 0;
<% } %>
	padding: 0 0 0 0;
}

SPAN.label {
	color:#E0E0C0;
}

NOBR.STUDY_INFO {
	font-family: monospace;
	font-size: 9pt;
}

SPAN.DIRTEXT {
	font-size:9pt;
}

TD.BAR {
	background-color:#405050; /* #687686 */
	margin:0 0 0 0;
	padding:0 0 0 0;
}

TD.STRIP {
	background-color: black;
	margin:0 0 0 0;
	padding:0 0 0 0;
}

TD.CANVAS {
	background-color: #102020;
	margin:0 0 0 0;
	padding:0 0 0 0;
}

TD.ARROW {
	background-color:#405050; /* #687686 */
}


.IMG-CONTAINER {
	/*position:relative;*/
}


DIV.ANN {
	position:absolute;
	height:<%= LayoutTable.layout.height - 38 %>px;
	width:<%=LayoutTable.layout.width%>px;
	margin:0 0 0 0;
	padding:0 0 0 0;
	/*visibility: hidden;*/
	z-index:1;
}
DIV.ACT {
	position:absolute;
	height:<%=LayoutTable.layout.height-38%>px;
	width:<%=LayoutTable.layout.width%>px;
	margin:0 0 0 0;
	padding:0 0 0 0;
	visibility: hidden;
	z-index:2;
}

DIV.SLIDER-ACT {
	position:absolute;
	top:<%=(kInfoBarHeight + kMenuBarHeight + kStripWidth)%>;
	left:<%=(QSV.window_width - kStripWidth)%>;
	height:<%=SliderPanel.panel_height%>;
	width:<%=kStripWidth%>;
	margin:0 0 0 0;
	padding:0 0 0 0;
	visibility: hidden;
	z-index:2;
}
DIV.SLIDER-IND {
	position:absolute;
	top:<%=(kInfoBarHeight + kMenuBarHeight + kStripWidth)%>;
	left:<%=(QSV.window_width - kStripWidth)%>;
	height:<%=SliderPanel.ind_height%>;
	width:<%=kStripWidth%>;
	margin:0 0 0 0;
	padding:0 0 0 0;
	visibility: hidden;
	z-index:1;
	border-color:#FFAA00;
	border-width:1;
	border-style:solid;
}
LAYER.SLIDER-ACT {
	margin:0 0 0 0;
	padding:0 0 0 0;
}
LAYER.SLIDER-IND {
	margin: 0 0 0 0;
	padding-top:<%=(SliderPanel.ind_height - 8)%>;
	padding-bottom:0;
	padding-left:<%=(kStripWidth - 8)%>;
	padding-right:0;
	border-color:#FFAA00;
	border-width:1;
	border-style:solid;
}

.ANNTEXT {
	font-size:9pt;
	color:#FFAA00;
}

NOBR.BarText {
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
}

TD.MenuButton {
	color: white;
	font-weight: bold;
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	background-color: #687686;
	padding: 0 7 0 7;
	margin: 0 0 0 0;
}

TD.VarText {
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	background-color: #304040;
	padding: 0 0 0 2;
	margin: 0 0 0 0;
}

A.DrMenu-item {
	color: white;
	font-weight: bold;
	text-decoration: none;
}

A:hover {
	color:#FFAA00;
}

LAYER.DrMenu-list {
	color: white;
	background-color: #687686;
	border-width: 1 2 2 1;
	border-style: solid;
	border-color: #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
}
DIV.DrMenu-list {
	position: absolute;
	z-index: 4;
 	display:none;
	color: white;
	background-color: #687686;
	border-width: 1 2 2 1;
	border-style: solid;
	border-color: #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
}
NOBR.DrMenu-listItem {
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
}

DIV.SeriesDetail {
	position: absolute;
	left: 0;
	z-index:4;
	width: <%=(QSV.window_width - kStripWidth - 2)%>px;
	display:none;
	background-color:#405050;
	border: 1px solid #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	color:#E0E0C0;
}
.for_select {
    padding: 3px 7px 7px 7px;
    margin-left: -3px;
    position: inherit;
}

/****************************************************************************************/
</STYLE>
<!--[if lte IE 7]>
    <script type="text/javascript">
        $(document).ready(function(){
            var w = 0;
            $(".control-bar>.filter-group").each(function(i,obj){
                w += $(obj).width();
            });

            w = ($(".control-bar").width() - w - 30)/2;
            if (w<25) w=25;
            $($(".control-bar>.filter-group").eq(0)).css("margin-left",w+"px");
        });
    </script>

    <style type="text/css">
        DIV.ANN {

            position: inherit;
        }
        .control-bar div.filter-group {
            float: left;
        }

    </style>
<![endif]-->
<BODY onLoad="onFirstLoad()" >
	<div class="control-bar" >
			<div class="filter-group first_one">
				<select id="layout" class="chzn-select blue" style="width:150px;display:none">
					<optgroup label="Layout">
					<%
						string requestLayout = LayoutTable.layout.rows.ToString() + "," + LayoutTable.layout.cols.ToString();
						foreach (LayoutEntry layout in LayoutTable.table) {
							string value = layout.rows.ToString() + "," + layout.cols.ToString();
							Response.Write("<option value='" + value +"'" + (requestLayout == value?" selected='selected'":"") + ">"+layout.cols.ToString() + " X " + layout.rows.ToString() + " [" + (layout.width > layout.height ? layout.width : layout.height).ToString() + "]"+"</option>");
						}
						Response.Write("<option value=''>---------</option>");
						Response.Write("<option value='2'>"+(QSV.fit == "2" ? "&lt; Scale of 2 &gt;" : "&lt; Scale of 2 &gt;")+"</option>");
						Response.Write("<option value='F'>"+(QSV.fit == "F" ? "&lt; Fit &gt;" : "Fit")+"</option>");
					%>
					</optgroup>
				</select>
			</div>
			<div class="filter-group">
				<select id="overlay" class="chzn-select blue" style="width:120px;display:none">
					<optgroup label="Overlay">
					<option value="N" <%= QSV.overlay == "N" ? "selected='selected'" : "" %>>Number</option>
					<option value="D" <%= QSV.overlay == "D" ? "selected='selected'" : "" %>>Detail</option>
					<option value="." <%= QSV.overlay == "." ? "selected='selected'" : "" %>>None</option>
					</optgroup>
				</select>
				<label></label>
			</div>
			<div class="filter-group">
				<select id="action" class="chzn-select blue" style="width:98px;display:none">
					<option value="P" <%= QSV.action == "P" ? "selected='selected'" : "" %>>Page</option>
					<option value="Z" <%= QSV.action == "Z" ? "selected='selected'" : "" %>>Zoom/Pan</option>
					<% if (((ImageObject)ImageList[0]).bits != 8) { %>
					<option value="V" <%= QSV.action == "V" ? "selected='selected'" : "" %>>W/L</option>
					<% } %>
					<option value="." <%= QSV.action == "." ? "selected='selected'" : "" %>>None</option>
				</select>
				<!--label id="action-label" class="for_select" style="margin-left:0px">Page</label-->
			</div>
			<div class="filter-group">
			<select id="preset" class="chzn-select blue" style="width:120px;display:none">
					<optgroup label="Preset">
					<%
						string selected_voi = VOITable.wc.ToString() + "," + VOITable.ww.ToString();
						string voi_val = "";
						foreach (VOIEntry voi in VOITable.table) {
							voi_val = voi.wc.ToString() + "," + voi.ww.ToString();
							Response.Write("<option value='" + voi_val + "'" + (voi_val == selected_voi ? " selected='selected'" : "") + ">"+voi.label+"</option>");
						}
					%>
					</optgroup>
			</select>
			<label class="for_select" style="margin-left:0px">L: <span id="preset-l">2089</span> &nbsp;&nbsp; W: <span id="preset-w">4569</span></label>
			</div>
			<div class="filter-group">
				<select id="zoom" class="chzn-select blue" style="width:80px;display:none">
					<optgroup label="Zoom">
					<option value="1" <%= QSV.zoom == 1 ? "selected='selected'" : "" %>>X 1</option>
					<option value="1.5" <%= QSV.zoom == 1.5 ? "selected='selected'" : "" %>>X 1.5</option>
					<option value="2" <%= QSV.zoom == 2 ? "selected='selected'" : "" %>>X 2</option>
					<option value="3" <%= QSV.zoom == 3 ? "selected='selected'" : "" %>>X 3</option>
					<option value="4" <%= QSV.zoom == 4 ? "selected='selected'" : "" %>>X 4</option>
					<option value="5" <%= QSV.zoom == 5 ? "selected='selected'" : "" %>>X 5</option>
					<option value="8" <%= QSV.zoom == 8 ? "selected='selected'" : "" %>>X 8</option>
					<option value="10" <%= QSV.zoom == 10 ? "selected='selected'" : "" %>>X 10</option>
					</optgroup>
				</select>
				<label id="zoom-label" class="for_select"></label>
			</div>
			<div class="clear"></div>
	</div>
<div class="x-ray">
<DIV class="caption" STYLE="width:<%=QSV.window_width%>px;height:<%=kInfoBarHeight%>px;">
	<NOBR CLASS="STUDY_INFO" style="line-height:<%=kInfoBarHeight%>px;">
		<span style="overflow: hidden; display: inline-block; max-width: <%=QSV.window_width-50%>px"><%print_study_info(DOM);%><%=" "%><%print_study_info_ex(DOM, NumImages);%><%=" "%></span>
		<span style="display: inline-block; overflow: hidden"><%printSeriesDetailButton();%></span>
	</NOBR>
</DIV>
<div>
<TABLE ALIGN="LEFT" HSPACE="0" VSPACE="0" CELLPADDING="0" CELLSPACING="0" BORDER="0" BGCOLOR="BLACK" WIDTH="<%=QSV.window_width%>" HEIGHT="<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight %>">
<TR STYLE="height:<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight%>;">
<!-- CANVAS area begin -->
<TD STYLE="width:<%=QSV.window_width - kStripWidth%>;" NOWRAP ALIGN="LEFT" VALIGN="TOP" CLASS="CANVAS"><%printImageTable(LayoutTable.layout, QSV.window_height - kInfoBarHeight - kMenuBarHeight, QSV.window_width - kStripWidth);%></TD>
<!-- CANVAS area end -->
<!-- STRIP area begin -->
<TD STYLE="width:<%=kStripWidth%>;" NOWRAP ALIGN="LEFT" VALIGN="TOP" CLASS="STRIP"><%printStrip(QSV.window_height - kInfoBarHeight - kMenuBarHeight, kStripWidth, NumImages, SliderPanel, QSV);%></TD>
<!-- STRIP area end -->
</TR>
</TABLE>
<% printSeriesDetail(DOM, QSV); %>
<div style="clear:both"></div>
</div>
<style type="text/css">
    .control-bar .filter-group.first_one {margin-left: 25px;}
    #reload {width:16px;height: 16px;display: inline-block;background: url("media/images/reload_x16.png") center center no-repeat;}

    @group Retina compatibility
    @media only screen and (-webkit-min-device-pixel-ratio: 2), only screen and (min-resolution: 144dpi)  {
    a #reload {
            width:24px;height: 24px;
            background-mages: url("media/images/reload_x24.png")
        }
    }
    @end
</style>
<DIV STYLE="position:absolute;top:7px;left:20px;z-index:1300">
    <A HREF="javascript:parent.reload_viewer()">
        <i id="reload"></i>
    </A>
</DIV>
</BODY>
</HTML>
